Package org.opencv.xfeatures2d

## Class TEBLID

- java.lang.Object
- - org.opencv.core.Algorithm
  - - org.opencv.features.Feature2D
    - - org.opencv.xfeatures2d.TEBLID

-     public class TEBLID
      extends Feature2D

  Class implementing TEBLID (Triplet-based Efficient Binary Local Image Descriptor), described in CITE: Suarez2021TEBLID. TEBLID stands for Triplet-based Efficient Binary Local Image Descriptor, although originally it was called BAD \cite Suarez2021TEBLID. It is an improvement over BEBLID \cite Suarez2020BEBLID, that uses triplet loss, hard negative mining, and anchor swap to improve the image matching results. It is able to describe keypoints from any detector just by changing the scale_factor parameter. TEBLID is as efficient as ORB, BEBLID or BRISK, but the triplet-based training objective selected more discriminative features that explain the accuracy gain. It is also more compact than BEBLID, when running the [AKAZE example](https://github.com/opencv/opencv/blob/5.x/samples/cpp/tutorial_code/features2D/AKAZE_match.cpp) with 10000 keypoints detected by ORB, BEBLID obtains 561 inliers (75%) with 512 bits, whereas TEBLID obtains 621 (75.2%) with 256 bits. ORB obtains only 493 inliers (63%). If you find this code useful, please add a reference to the following paper: <BLOCKQUOTE> Iago Suárez, José M. Buenaposada, and Luis Baumela. Revisiting Binary Local Image Description for Resource Limited Devices. IEEE Robotics and Automation Letters, vol. 6, no. 4, pp. 8317-8324, Oct. 2021. </BLOCKQUOTE> The descriptor was trained in Liberty split of the UBC datasets \cite winder2007learning .

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static int` | `SIZE_256_BITS` |
    `static int` | `SIZE_512_BITS` |

    - ### Fields inherited from class org.opencv.core.Algorithm

      `nativeObj`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `TEBLID​(long addr)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static TEBLID` | `__fromPtr__​(long addr)` |
    `static TEBLID` | `create​(float scale_factor)` | Creates the TEBLID descriptor.
    `static TEBLID` | `create​(float scale_factor, int n_bits)` | Creates the TEBLID descriptor.
    `protected void` | `finalize()` |
    `java.lang.String` | `getDefaultName()` | Returns the algorithm string identifier.

    - ### Methods inherited from class org.opencv.features.Feature2D

      `compute, compute, defaultNorm, descriptorSize, descriptorType, detect, detect, detect, detect, detectAndCompute, detectAndCompute, empty, read, write`

    - ### Methods inherited from class org.opencv.core.Algorithm

      `clear, getNativeObjAddr, save`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### SIZE_256_BITS

          public static final int SIZE_256_BITS

      See Also:
        Constant Field Values

    - #### SIZE_512_BITS

          public static final int SIZE_512_BITS

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### TEBLID

          protected TEBLID​(long addr)

  - ### Method Detail

    - #### __fromPtr__

          public static TEBLID __fromPtr__​(long addr)

    - #### create

          public static TEBLID create​(float scale_factor,
                                      int n_bits)

      Creates the TEBLID descriptor.
      Parameters:
        `scale_factor` - Adjust the sampling window around detected keypoints:
        - <b> 1.00f </b> should be the scale for ORB keypoints
        - <b> 6.75f </b> should be the scale for SIFT detected keypoints
        - <b> 6.25f </b> is default and fits for KAZE, SURF detected keypoints
        - <b> 5.00f </b> should be the scale for AKAZE, MSD, AGAST, FAST, BRISK keypoints
        `n_bits` - Determine the number of bits in the descriptor. Should be either TEBLID::SIZE_256_BITS or TEBLID::SIZE_512_BITS.
      Returns:
        automatically generated

    - #### create

          public static TEBLID create​(float scale_factor)

      Creates the TEBLID descriptor.
      Parameters:
        `scale_factor` - Adjust the sampling window around detected keypoints:
        - <b> 1.00f </b> should be the scale for ORB keypoints
        - <b> 6.75f </b> should be the scale for SIFT detected keypoints
        - <b> 6.25f </b> is default and fits for KAZE, SURF detected keypoints
        - <b> 5.00f </b> should be the scale for AKAZE, MSD, AGAST, FAST, BRISK keypoints
        TEBLID::SIZE_256_BITS or TEBLID::SIZE_512_BITS.
      Returns:
        automatically generated

    - #### getDefaultName

          public java.lang.String getDefaultName()

      Description copied from class: `Algorithm`
      Returns the algorithm string identifier. This string is used as top level xml/yml node tag when the object is saved to a file or string.
      Overrides:
        `getDefaultName` in class `Feature2D`
      Returns:
        automatically generated

    - #### finalize

          protected void finalize()
                           throws java.lang.Throwable

      Overrides:
        `finalize` in class `Feature2D`
      Throws:
        `java.lang.Throwable`